# MagnetModel

Library in charge of magnetic strenghs to coil currents calculation. This library implements computation in the two directions (from currents to magnetic coeffs and from magnetic coeffs to currents). Thank's to **Gael Lebec** (from ASD) who is the author of the sextupole model.



## Elettra 2.0 fork

The library is a fork from the original esrf library. Reasons for forking:
 1) Elettra 2.0 has some differences in the combined magnets composition (set of multipoles) and in the excitation schemes for combined magnets.
 2) We must use our local gitlab repository in order to use the INAU deployment system.

### Credits

Thanks to Jean-Luc Pons (ESRF) , author of the libray , and Simone Maria Liuzzo (ESRF) for provinding the initial tutorial and training.

## Cloning the original project

To clone this project, simply type:

```
git clone git@gitlab.esrf.fr:accelerators/Magnets/MagnetModel.git
```

## Building and Installation

### Dependencies

The project has the following dependencies.

#### Project Dependencies 

* [Eigen](http://eigen.tuxfamily.org/index.php?title=Main_Page)

#### Toolchain Dependencies

* C++11 compliant compiler.
* CMake 3.0 or greater is required to perform the build. 


### Build library

Instructions on building the project.

CMake example:

```bash
cd MagnetModel/lib
mkdir -p build/<os>
cd build/<os>
cmake ../.. -DCMAKE_INSTALL_PREFIX=<folder where lib must be installed>
make
```
**INSTALL_DIR** for elettra and elettra2 is /runtime

### Installation

In the same folder than above

```bash
make install
```
The include files and the library will be installed in the folder given during the cmake command

## Tests

To build the test software:
* Adapt the **INSTALL_DIR** variable in the CMakeLists.txt file to the folder you have used as installation folder.

```bash
cd SextuCorrModels/test
mkdir -p build/<os>
cd build/<os>
cmake ../..
make
```
To run the test software (in the same folder than above)

```bash
./TestSextuCorr <Path to the Parameter files folder>
```
